function [ output_correct ] = standard_correlation_1bit( rx_data, sample_rate_ref )
%STANDARD_CORRELATION_1BIT For testing a standard offset binary output correlator design

    % Read the test vectors applied to the unit and calculate the expected
    % response. Also read the result vectors from the testbench, and plot
    % against the expected results.
    
    % Matched filter algorithm
    % The Barker code
    barker_11_1bit = [1 1 1 0 0 0 1 0 0 1 0];
    pn_code_1bit = reshape((barker_11_1bit' * ones(1, sample_rate_ref))', 1, length(barker_11_1bit)*sample_rate_ref);
    input_reg = zeros(1, length(pn_code_1bit));
    % Flip the PN code from right to left, so we xcorr and not convolute
    pn_code_1bit = fliplr(pn_code_1bit);
    output_correct = zeros(1, length(rx_data));
    for k = 1:length(rx_data)
        % Shift in new data
        input_reg(2:end) = input_reg(1:end-1);
        input_reg(1) = rx_data(k);

        % Correct bit counts 1, wrong bit counts 0
        for l = 1:length(pn_code_1bit)
            if (pn_code_1bit(l) == input_reg(l))
                output_correct(k) = output_correct(k) + 1;
            end
        end
    end
end

