function [ rx_data ] = variable_bit_quantize( input_vector, ADC_bits )
%VARIABLE_BIT_QUANTIZE Quantize vector into discrete values in [-1, 1]

    % Space between each ADC level
    adc_interval = 2 / ((2^ADC_bits)-1);
    % Vector containing valid ADC values in [-1,1]
    adc_span = (0:adc_interval:2) - 1;
    % Vector used to place ADC values
    adc_interval = 2 / (2^ADC_bits);
    adc_check = (0:adc_interval:2) - 1;
    adc_check = adc_check(2:end);

    % Next the data is quantized to allowable levels
    rx_data = zeros(1, length(input_vector));
    for i = 1 : length(input_vector)
        % Quantize each sample
        for j = 1 : length(adc_check)
                if input_vector(i) < adc_check(j)
                    rx_data(i) = adc_span(j);
                    break;
                end
        end
        if j == length(adc_check)
            rx_data(i) = adc_span(end);
        end
    end
end

