//-----------------------------------------------------------------------------
//
// Title       : voter_unit
//
//-----------------------------------------------------------------------------
//
// Description : 5-bit voter
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module voter_unit_five (ballots, vote);
	
	input [4:0] ballots;
	output vote;
	
	wire w1, w2;
	reg vote;
	
	// Determine whether a 1 or 0 is the state held by the most inputs
	and(w1, ballots[3], ballots[4]);
	or(w2, ballots[3], ballots[4]);
	
	// Mux
	always @(*) begin	  
			case (ballots[2:0])
				0 : vote = 0;
				1 : vote = w1;
				2 : vote = w1;
				3 : vote = w2;
				4 : vote = w1; 
				5 : vote = w2;
				6 : vote = w2;
				7 : vote = 1;
			endcase 
		end
	
endmodule