//-----------------------------------------------------------------------------
//
// Title       : voter_unit
//
//-----------------------------------------------------------------------------
//
// Description : 3-bit voter
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module voter_unit (ballots, vote);
	
	input [2:0] ballots;
	output vote;
	
	wire vote, w1, w2, w3;
	
	// Determine whether a 1 or 0 is the state held by the most inputs
	// vote = AB + BC + AC
	and(w1, ballots[0],	ballots[1]); 
	and(w2, ballots[1],	ballots[2]);
	and(w3, ballots[0],	ballots[2]);
	or(vote, w1, w2, w3);
	
endmodule