//-----------------------------------------------------------------------------
//
// Title       : eleven_bit_cnter
// Design      : corr_counter_block
// Author      : 
// Company     : 
//
//-----------------------------------------------------------------------------
//
// Description : Counts the number of set bits in an 11-bit input vector
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module eleven_bit_cnter (in, sum);
	
	input [10:0] in;
	output [3:0] sum; 
	
	wire [3:0] sum;
	wire [2:0] sevensum, foursum;
	
	// The seven bit parallel counter
	seven_bit_cnter sevenbitter (
		.in(in[6:0]),
		.sum(sevensum)
		);
	
	// The five bit parallel counter
	four_bit_cnter fourbitter (
		.in(in[10:7]),
		.sum(foursum)
		);
	
	// Find the sum
	assign sum = sevensum + foursum;
	
endmodule
