//-----------------------------------------------------------------------------
//
// Title       : upcounter
//
//-----------------------------------------------------------------------------
//
// Description : 4-bit counter, up or no count permitted for each clock pulse
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module upcounter (count, reset, clk, up);
	
	input reset; 
	input clk;
	input up;
	output [3:0] count;
	
	reg [3:0] count;
	
	// With each clock, either count up, or don't count at all
	always @ (posedge clk or negedge reset)
		begin
			if (!reset) begin  
					count <= 0;
			end else begin
					// Count!
					if (up) begin 
							count <= count + 1;
						end			
				end
		end	
	
endmodule
