//-----------------------------------------------------------------------------
//
// Title       : bit_cnter_TB
// Design      : corr_counter_block
// Author      : 
// Company     : 
//
//-----------------------------------------------------------------------------
//
// File        : c:\my_designs\corr_counter_block\corr_counter_block\src\twenty_two_bit_cnter_TB.v
// Generated   : Thu Feb 13 12:16:39 2014
// From        : interface description file
// By          : Itf2Vhdl ver. 1.22
//
//-----------------------------------------------------------------------------
//
// Description : Test bench for parallel adders up to 16 bits
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module bit_cnter_TB ();
	
	localparam n = 4;	// Input bits 
	localparam y = 3;	// Output bits
	
	// Connections to the counter, outputs wire, inputs reg
	wire [y-1:0] setbitsCnt;
	reg [n-1:0] currentBitVector;		
	
	// Some testbench variables	
	integer i, errors;
	reg [y-1:0] setbitsCorrect;
	
	// The device under test	
	four_bit_cnter_ha DUT (
		.in(currentBitVector), 
		.sum(setbitsCnt)
		);
	
	// Start up initializations
	initial
		begin 
			$display($time, " << Starting test bench >>");
			currentBitVector = (2**n) - 1;
			errors = 0;
			
			// Determine the correct answer
			setbitsCorrect = 0;	
			i = 0;
			for (i=0; i<n; i=i+1)	   
				begin
					if (currentBitVector[i] == 1) begin
							setbitsCorrect = setbitsCorrect + 1;
						end
				end
			//Verify the adder output
			#1 if (setbitsCorrect != setbitsCnt) begin
					$display(" Error for input: %b", currentBitVector);
					errors = errors + 1;
				end
		end
	
	// Increment the input vector every 10ns
	always
		#9 begin
			if (currentBitVector == 0) begin
					// Final vector has been tested!
					$display($time, " << Testing complete, %d erros detected! >>", errors);
					$finish;
			end else begin
					currentBitVector = currentBitVector - 1;
					
					// Determine the correct answer
					setbitsCorrect = 0;	
					i = 0;
					for (i=0; i<n; i=i+1)	   
						begin
							if (currentBitVector[i] == 1) begin
									setbitsCorrect = setbitsCorrect + 1;
								end
						end
					
					//Verify the adder output
					#1 if (setbitsCorrect != setbitsCnt) begin
							$display(" Error for input: %b", currentBitVector);
							errors = errors + 1;
						end
					
				end
		end
	
endmodule
