//-----------------------------------------------------------------------------
//
// Title       : eight_bit_cnter_2x4 
// Design      : corr_counter_block
// Author      : 
// Company     : 
//
//-----------------------------------------------------------------------------
//
// Description : Counts the number of set bits in a 8-bit input vector
//				 Uses two 3-bit counters, and a 2-bit counter. Carry-save
//				 adder used to sum the output.
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module eight_bit_cnter_2x4 (in, sum);
	
	input [7:0] in;
	output [3:0] sum; 
	
	wire [3:0] sum;
	wire [2:0] partialsum [0:1];
	
	// The 3- and 2-bit parallel counters
	four_bit_cnter fourbitter0 (
		.in(in[3:0]),
		.sum(partialsum[0])
		);
	four_bit_cnter fourbitter1 (
		.in(in[7:4]),
		.sum(partialsum[1])
		);
	
	assign sum = partialsum[0] + partialsum[1];
	
endmodule