//-----------------------------------------------------------------------------
//
// Title       : four_bit_cnter
// Design      : corr_counter_block
//
//-----------------------------------------------------------------------------
//
// Description : 4-bit parallel counter
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module four_bit_cnter (in, sum);
	
	output [2:0] sum;
	input [3:0] in;  
	
	wire w1, w2, w3, w4, w5;
	
	// S1 =  (A+B+C)(A+B+D)(A+C+D)(B+C+D)not(ABCD)
	or(w1, in[0], in[1], in[2]);
	or(w2, in[0], in[1], in[3]);
	or(w3, in[0], in[2], in[3]);
	or(w4, in[1], in[2], in[3]);
	nand(w5, in[0], in[1], in[2], in[3]);
	and(sum[1], w1, w2, w3, w4, w5);
	
	// S2 = ABCD
	and(sum[2], in[0], in[1], in[2], in[3]);
	
	// S0 = A xor B xor C xor C xor D
	xor(sum[0], in[0], in[1], in[2], in[3]);
	
endmodule
