//-----------------------------------------------------------------------------
//
// Title       : four_bit_cnter_sel
// Design      : corr_counter_block
//
//-----------------------------------------------------------------------------
//
// Description : 4-bit parallel counter, using a selector and predetermined
//					results.
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module four_bit_cnter_sel (in, sum); 
	
	output [2:0] sum;
	input [3:0] in;
	
	reg [2:0] sum;
	
	// Selector used to pick the correct output
	always @(in) begin	  
			case (in)
				0 : sum = 0;
				1 : sum = 1;
				2 : sum = 1;
				3 : sum = 2;
				4 : sum = 1; 
				5 : sum = 2;
				6 : sum = 2;
				7 : sum = 3;
				8 : sum = 1;
				9 : sum = 2;
				10 : sum = 2;
				11 : sum = 3;
				12 : sum = 2;
				13 : sum = 3;
				14 : sum = 3;
				15 : sum = 4;
			endcase 
		end
	
endmodule
