//-----------------------------------------------------------------------------
//
// Title       : hasher_zero
// Design      : hash_corr
//
//-----------------------------------------------------------------------------
//
// Description : Determines the new hash for a given old hash. Assume the next
//					sample is 0.
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module hasher_zero (old_hash, new_hash);
	
	output [4:0] new_hash;
	input [4:0] old_hash;  
	
	reg [4:0] new_hash;
	
	always @ (*)
		begin
			new_hash = 0;
			case (old_hash)	
				5'b00000 : new_hash = 5'b00000;
				5'b10000 : new_hash = 5'b00000;
				5'b00001 : new_hash = 5'b00000;
				5'b10001 : new_hash = 5'b00000;	
				
				5'b00100 : new_hash = 5'b00001;
				5'b00101 : new_hash = 5'b00001;
				5'b11011 : new_hash = 5'b00001;
				
				5'b00010 : new_hash = 5'b00100;
				5'b00011 : new_hash = 5'b00100;
				5'b11001 : new_hash = 5'b00100;
				
				5'b00110 : new_hash = 5'b00101;
				5'b00111 : new_hash = 5'b00101;
				5'b11111 : new_hash = 5'b00101;
				
				5'b01001 : new_hash = 5'b10100;
				5'b10010 : new_hash = 5'b10100;
				5'b10011 : new_hash = 5'b10100;
				
				5'b01011 : new_hash = 5'b10001;
				5'b10101 : new_hash = 5'b10001;
				5'b10100 : new_hash = 5'b10001;
				
				5'b01101 : new_hash = 5'b11011;
				5'b11000 : new_hash = 5'b11011;
				5'b11100 : new_hash = 5'b11011;
				
				5'b01111 : new_hash = 5'b10101;
				5'b10110 : new_hash = 5'b10101;
				5'b10111 : new_hash = 5'b10101;
				
				5'b01100 : new_hash = 5'b01011;
				5'b01000 : new_hash = 5'b01011;
				5'b11101 : new_hash = 5'b01011;
				
			endcase
		end
	
endmodule
