//-----------------------------------------------------------------------------
//
// Title       : last_sample_dec
// Design      : hash_corr
//
//-----------------------------------------------------------------------------
//
// Description : Determines the last ADC sample in a sequence, from a 5-bit hash.
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module last_sample_dec (hash, adc_pos, adc_neg);
	
	output adc_pos, adc_neg;
	input [4:0] hash;  
	
	wire mag, w1, w2;
	
	// Magnitude = LSB + (MSB*MSB[-1]) For the 4-bit code
	and(w1, hash[3], hash[2]);
	or(mag, hash[0], w1);
	
	// adc_pos = (NOT Sign) AND Magnitude
	not(w2, hash[4]);
	and(adc_pos, w2, mag);
	
	// adc_neg = Sign AND Magnitude
	and(adc_neg, hash[4], mag);
	
endmodule
